// File VECVIEW.CPP

#ifndef __BORLANDC__
#ifndef __TURBOC__
#error Borland C or Turbo C compiler required
#endif
#endif

#include <bios.h>
#include <ctype.h>
#include <dir.h>
#include <dos.h>
#include <graphics.h>
#include <math.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <values.h>

#define BUFSIZE 1024

typedef unsigned char byte;

unsigned
    lowdef = 0,
    highdef = 0,
    in_graph = 0,
    input_line = 0,
    use_color = 1,
    spec_col [16][3] =          // speciale kleuren
	{
	    {  0,  0,  0},
	    {  0,  0, 21},
	    {  0,  0, 31},
	    {  0,  0, 42},
	    { 21,  0, 42},
	    { 31,  0, 42},
	    { 42,  0, 42},
	    { 53,  0, 42},
	    { 63,  0, 42},
	    { 63, 21, 42},
	    { 63, 31, 42},
	    { 63, 42, 42},
	    { 63, 53, 42},
	    { 63, 63, 42},
	    { 63, 63, 53},
	    { 63, 63, 63}
	};
char
    programname [MAXFILE],
    *filename = 0,
    buffer [BUFSIZE + 1],
    buf [BUFSIZE + 1],
    label [BUFSIZE + 1],
    *spec [] = {"   ",
		"  ",
		" ",
		"",
		"",
		"",
		"",
		"",
		"",
		"",
		"۲",
		"۲",
		""};

float
    low,
    high;

void
    process_args (int argc, char *argv []),
    trim (),
    errit (char const *format, ...);
int
    getindex (float f, int min, int max);
char
    *getline (FILE *fp, int required, char const *filename),
    *get_arg (int *argc, char *argv [], int *index);

int main (int argc, char *argv [])
{
    int
	xmax,
	ymax,
	xd,
	yd,
	x = 0,
	y = 0,
	gdriver = DETECT,
	gmode,
	errorcode;
    unsigned
	i,
	s_len = 0,
	nr_vec = 0,
	vectorlengte;
    float
	min = MAXFLOAT,
	max = -MAXFLOAT,
	value;
    palettetype
	pal;
    FILE
	*fp;

    process_args (argc, argv);

    if (! filename)
	errit ("Bestandsnaam ontbreekt");

    if (! (fp = fopen (filename, "r")))
	errit ("Bestand %s niet gevonden", filename);

    getline (fp, 1, filename);

    if (sscanf (buffer, " %u", &vectorlengte) != 1)
	return 1;

    while (getline (fp, 0, 0)) {
	nr_vec++;
	i = strlen (buffer);
	if (i > s_len)
	    s_len = i;
	for (i = 0; i < vectorlengte; i++) {
	    getline (fp, 1, filename);
	    sscanf (buffer, " %f", &value);
	    if (value > max)
		max = value;
	    if (value < min)
		min = value;
	}
    }
    fclose (fp);

    if (min == max) {
        min -= 0.5;
        max += 0.5;
    }
    if (! lowdef)
        low = ((min < 0.0) ? min : 0.0);
    if (! highdef)
        high = ((max > 1.0) ? max : 1.0);
    if (low > high) {
        low = ((min < 0.0) ? min : 0.0);
        high = ((max > 1.0) ? max : 1.0);
    }

    if (use_color) {
        registerbgidriver (EGAVGA_driver);
        initgraph (&gdriver, &gmode, getenv ("BGI"));
	errorcode = graphresult();
	if (errorcode != grOk) {
	    errit (
		"%s\n\n"
		"Environment variable BGI can be used to point to\n"
		"directory where graphic driver files are to be found",
		grapherrormsg (errorcode)
	    );
	}
	in_graph = 1;

	if (getmaxcolor () < 15)
	    errit ("Videokaart met minimaal 16 kleuren vereist");

	sprintf (buffer, "%*s", s_len, "");
	xmax = getmaxx ();
	ymax = getmaxy ();
	xd = (xmax - 5 - textwidth (buffer)) / vectorlengte;
	yd = ymax / nr_vec;
        if (xd > getmaxx () / 10)
            xd = getmaxx () / 10;
        if (yd > getmaxy () / 10)
            yd = getmaxy () / 10;

	getpalette (&pal);

	for (i = 0; i <= getmaxcolor (); i++)
	    setrgbpalette (
		pal.colors [i],
		spec_col [i][0],
		spec_col [i][1],
		spec_col [i][2]
	    );
	settextjustify (LEFT_TEXT, CENTER_TEXT);
    }

    fp = fopen (filename, "r");
    getline (fp, 1, filename);
    while (getline (fp, 0, 0)) {
	sscanf (buffer, " %s", label);
	for (i = 0; i < vectorlengte; i++) {
	    getline (fp, 1, filename);
	    sscanf (buffer, " %f", &value);
            value = (value - low) / (high - low);
            if (value < 0.0)
                value = 0.0;
            else if (value > 1.0)
                value = 1.0;
	    if (use_color) {
		setfillstyle (SOLID_FILL, getindex (value, 1, 15));
		bar (x, y, x + xd - 1, y + yd - 1);
		setcolor (0);
		setlinestyle (SOLID_LINE, 0, 1);
		rectangle (x, y, x + xd, y + yd);
		setcolor (5);
		setlinestyle (DOTTED_LINE, 0, 1);
		rectangle (x, y, x + xd, y + yd);
		x += xd;
	    } else
		printf ("|%s", spec [getindex (value, 0, 12)]);
	}
	if (use_color) {
	    setcolor (15);
	    outtextxy (x + 5, y + yd / 2, label);
	    y += yd;
            x = 0;
	} else
	    printf ("| %s\n", label);
    }
    fclose (fp);

    if (in_graph) {
	_bios_keybrd (_KEYBRD_READ);
	closegraph ();
	in_graph = 0;
    }

    if (min < low)
        fprintf (stderr, "Scaling: [%f, %f] -> 0\n", min, low);
    fprintf (stderr, "Scaling: [%f, %f] -> [0, 1]\n", low, high);
    if (high < max)
        fprintf (stderr, "Scaling: [%f, %f] -> 1\n", high, max);

    return 0;
}

int getindex (float f, int min, int max)
{
    int i = min + (int) (f * (float)(max - min + 1));
    return (i > max) ? max : i;
}

void process_args (int argc, char *argv [])
{
    fnsplit (argv [0], 0, 0, programname, 0);
    strupr (programname);

    if (argc == 1) {
        fprintf (
	    stderr,
            "\nVector Viewer\n"
            "\n(c) P. Kleiweg 1996\n"
            "\nSyntax: %s -i file.vec [-t] [-l float] [-u float]\n"
	    "  -t: tekst uitvoer\n"
            "  -l: lower bound\n"
            "  -u: upper bound\n",
	    programname
	);
	exit (1);
    }

    for (int i = 1; i <argc; i++) {
	strupr (argv [i]);
	if ((argv [i][0] == '/') || (argv [i][0] == '-'))
            switch (argv [i][1]) {
                case 'I':
                    filename = strdup (get_arg (&argc, argv, &i));
                    break;
                case 'T':
                    use_color = 0;
		    break;
                case 'L':
                    low = atof (get_arg (&argc, argv , &i));
                    lowdef = 1;
		    break;
                case 'U':
                    high = atof (get_arg (&argc, argv , &i));
                    highdef = 1;
		    break;
		default:
                    errit ("Ongeldige parameter '%s'", argv [i]);
	    }
	else
            errit ("Invalid parameter \"%s\"", argv [i]);
    }
}

char *get_arg (int *argc, char *argv [], int *index)
{
    int
	i;
    i = 1;
    while (argv [*index][++i]) {
	if (! isspace (argv [*index][i]))
	    return argv [*index] + i;
    }
    if (*index == *argc - 1)
	errit ("Missing argument for \"%s\"", argv [*index]);
    return argv [++*index];
}

void errit (char const *format, ...)
{
    va_list
	list;

    if (in_graph) {
	closegraph ();
	in_graph = 0;
    }

    fprintf (stderr, "\nError %s: ", programname);

    va_start (list, format);
    vfprintf (stderr, format, list);

    fprintf (stderr, "\n\n");

    exit (1);
}

char *getline (FILE *fp, int required, char const *filename)
/* Lees een regel in
 * Plaats in buffer
 * Negeer lege regels en regels die beginnen met #
 */
{
    for (;;) {
	if (fgets (buffer, BUFSIZE, fp) == 0) {
	    if (required)
		errit ("Unexpected end of file in \"%s\"", filename);
	    else
		return 0;
	}
	input_line++;
	trim ();
	if (buffer [0])
	    return buffer;
    }
}

void trim ()
{
    int
	i;

    // commentaar verwijderen
    for (i = 0; buffer [i]; i++)
	if (buffer [i] == '#' && (i == 0 || isspace (buffer [i - 1]))) {
	    buffer [i] = '\0';
	    break;
	}

    // spaties aan het einde verwijderen
    for (i = strlen (buffer) - 1; i >= 0; i--)
	if (isspace (buffer [i]))
	    buffer [i] = '\0';
	else
	    break;

    // voorloopspaties verwijderen
    for (i = 0; buffer [i] && isspace (buffer [i]); i++)
	;
    memmove (buffer, buffer + i, strlen (buffer) + 1);
}

